import gconf
import pickle
import string
import sys
import threading
import os
import pynotify
import shutil
import grp
import getpass
import ldap
import subprocess

class GconfSerializer():
	
	def __init__(self):
		
		self.client=gconf.client_get_default()
		self.changeset=gconf.ChangeSet()
		self.dic={}
		self.dic2={}
		self.tmp=""
		self.entry=""
		self.frozen_path="/usr/share/lliurex-gnome-profile/failsafe/default.pkl"
	
	#def __init__


	def read_default_values(self,path):
		
		self.load_file(self.frozen_path)
		
		result=self.client.all_dirs(path)
		tmp=""
		
		for dir in result:
			
			if dir.rfind("schemas")==-1:
				self.read_default_values(dir)

			entries=self.client.all_entries(dir)
			
			for entry in entries:
				found=False
				
				if entry.key.find("/desktop/gnome")!=-1 or entry.key.find("/apps/panel")!=-1 or entry.key.find("/apps/nautilus")!=-1:

					if entry.value!=None:
						
						if entry.value.type == gconf.VALUE_BOOL:
							tmp=entry.value.get_bool()
							found=True
						elif entry.value.type == gconf.VALUE_STRING:
							tmp=entry.value.get_string()
							found=True
						elif entry.value.type == gconf.VALUE_INT:
							tmp=entry.value.get_int()
							found=True

						elif entry.value.type==gconf.VALUE_FLOAT:
							tmp=entry.value.get_float()
							found=True
						
						elif entry.value.type==gconf.VALUE_LIST:
							list_=entry.value.get_list()
							tmp=[]
							tipo=entry.value.get_list_type()
							if tipo == gconf.VALUE_STRING:
								tmp.append('str')
							elif tipo == gconf.VALUE_INT:
								tmp.append('int')
							elif tipo== gconf.VALUE_BOOL:
								tmp.append('bool')
								
							for item in list_:
								if item.type==gconf.VALUE_INT:
									tmp.append(item.get_int())
								if item.type==gconf.VALUE_STRING:
									tmp.append(item.get_string())
								if item.type==gconf.VALUE_BOOL:
									tmp.append(item.get_bool())
							
							found=True

						if found:	
							self.dic[entry.key]=tmp


				else:
					pass

	#def read_values



	
	def read_values(self,path):
		
		result=self.client.all_dirs(path)
		tmp=""
		for dir in result:
			
			if dir.rfind("schemas")==-1:
				self.read_values(dir)
			
			entries=self.client.all_entries(dir)
			for entry in entries:
				found=False
				
				if entry.value!=None:
						
					if entry.value.type == gconf.VALUE_BOOL:
						tmp=entry.value.get_bool()
						found=True
					elif entry.value.type == gconf.VALUE_STRING:
						tmp=entry.value.get_string()
						found=True
					elif entry.value.type == gconf.VALUE_INT:
						tmp=entry.value.get_int()
						found=True

					elif entry.value.type==gconf.VALUE_FLOAT:
						tmp=entry.value.get_float()
						found=True
						
					elif entry.value.type==gconf.VALUE_LIST:
						list_=entry.value.get_list()
						tmp=[]
						tipo=entry.value.get_list_type()
						if tipo == gconf.VALUE_STRING:
							tmp.append('str')
						elif tipo == gconf.VALUE_INT:
							tmp.append('int')
						elif tipo== gconf.VALUE_BOOL:
							tmp.append('bool')
							
						for item in list_:
							if item.type==gconf.VALUE_INT:
								tmp.append(item.get_int())
							if item.type==gconf.VALUE_STRING:
								tmp.append(item.get_string())
							if item.type==gconf.VALUE_BOOL:
								tmp.append(item.get_bool())
						
						found=True
					if found:	
						self.dic[entry.key]=tmp
				
		
	#def read_values

	def clear_unmodified_values(self,path):

		list=self.dic.items()
		dic_tmp={}
		
		result=self.client.all_dirs(path)
		
		for dir in result:
			self.clear_unmodified_values(dir)

		for dir in result:
			entries=self.client.all_entries(dir)
			
			for entry in entries:
				if entry.value!=None:
					
					if entry.value.type == gconf.VALUE_BOOL:
						if entry.key in self.dic:
							if entry.value.get_bool() == self.dic[entry.key]:
								del self.dic[entry.key]
							
					if entry.value.type == gconf.VALUE_INT:
						if entry.key in self.dic:
							if entry.value.get_int() == self.dic[entry.key]:
								del self.dic[entry.key]
					
					if entry.value.type == gconf.VALUE_FLOAT:
						if entry.key in self.dic:
							if entry.value.get_float() == self.dic[entry.key]:
								del self.dic[entry.key]

					if entry.value.type== gconf.VALUE_PAIR:
						if entry.key in self.dic:
							if entry.value.get_pair() == self.dic[entry.key]:
								del self.dic[entry.key]
					if entry.value.type==gconf.VALUE_STRING:
						if entry.key in self.dic:
							if entry.value.get_string() == self.dic[entry.key]:
								del self.dic[entry.key]

	#def clear_unmodified_values



	def write_values(self):
		
		list=self.dic.items()

		for item in list:
			
			if type(item[1]).__name__=="str":
				self.client.set_string(item[0],item[1])
			elif type(item[1]).__name__=="int":
				self.client.set_int(item[0],item[1])
			elif type(item[1]).__name__=="bool":
				self.client.set_bool(item[0],item[1])
			elif type(item[1]).__name__=="float":
				self.client.set_float(item[0],item[1])
			
			elif type(item[1]).__name__=="list":
				tmp2=[]

				if item[1][0]=='str':
					type_=gconf.VALUE_STRING
				if item[1][0]=='int':
					type_=gconf.VALUE_INT
				if item[1][0]=='bool':
					type_=gconf.VALUE_BOOL
				
				for element in item[1][1:]:
					
					if type(element).__name__=="str":
						value=gconf.Value(gconf.VALUE_STRING)
						value.set_string(element)
						tmp2.append(element)
											
					if type(element).__name__=="int":
						value=gconf.Value(gconf.VALUE_INT)
						value.set_int(element)
						tmp2.append(element)
											
					if type(element).__name__=="bool":
						value=gconf.Value(gconf.VALUE_BOOL)
						value.set_bool(element)
						tmp2.append(element)
				
				self.client.set_list(item[0],type_,tmp2)
				
				
			elif type(item[1]).__name__=="pair":
				pass

		
	#def write_values
	
	
	def print_keys(self):
		
		items=self.dic.items()
		
		for item in items:
			print item[0]
		
	#def print_keys
	
	def print_values(self):
		
		items=self.dic.items()
		for item in items:
			print "type: %s == %s"%(type(item[1]).__name__,item[1])
			
	#def print_values



	def write_file(self,path):

		f=open(path,'wb')
		pickle.dump(self.dic,f,-1)
		f.close()

	#def write_file
	
	def write_file2(self,path):
		
		f=open(path,'wb')
		self.read_default_values("/")
		pickle.dump(self.dic,f,-1)
		f.close()
		
	#def write_file	
	
	
	def load_file(self,path):
		
		f=open(path,'rb')
		self.dic=pickle.load(f)
		f.close()
		
	#def load_file



	def load_defaults(self,path):
		
		f=open(path,'rb')
		tmp={}
		tmp=pickle.load(f)
		f.close()
		
		for item in tmp:
			self.dic[item]=tmp[item]
			
		
	#def load_defaults
	
	def freeze(self):
		self.client.recursive_unset("/desktop",0)
		self.client.recursive_unset("/apps/metacity",0)
		self.client.recursive_unset("/apps/panel",0)
	#def freeze
	
	def is_freeze(self,username):
		final_groups = []
		p = subprocess.Popen(["llxcfg-showvars","LDAP_BASE_DN"],stdout=subprocess.PIPE)
		output = p.communicate()[0]
		if  output != "":
			basedn =  output.split("'")[1]
			connect_ldap = ldap.initialize('ldap://server')
			connect_ldap.PORT = 636
			ldap_result = connect_ldap.search_s(basedn,ldap.SCOPE_SUBTREE,'cn=flux')
			try:
				frozen_groups = ldap_result[0][1]['member']
				for x in frozen_groups:
					final_groups.append(x[x.find("=")+1:x.find(",")])
			except:
				return False
			user_groups = grp.getgrall()
			for group in user_groups:
				if username in group[3]:
					if group[0] in final_groups:
						return True
			return False
		return False
	#def is_freeze
	
#class PickleTest


if __name__=="__main__":
	
	pt=GconfSerializer()
	
	stop=False
	frozen=False

	if os.path.exists(os.path.expanduser("~/UserFiles/.llx-gnome-profile-manager/.stop")):
		stop=True
		
	if os.getuid() < 5000:
		sys.exit(0)



	if not stop:
		for i in range(1,len(sys.argv)):
		
			if sys.argv[i]=="--save":
				
				if i+1 <len(sys.argv):

					pynotify.init("Session Notify")
					n = pynotify.Notification( "Copiando sus archivos de perfil" , "No cancele la operacion", "user-home" )
					n.show()
					pt.read_values("/apps")
					pt.read_values("/desktop")
					pt.read_values("/system")
					
					pt.write_file(sys.argv[i+1])
					n.close()
					print("* Save complete")

				else:
					print "USAGE --save filename"
				break


			if sys.argv[i]=="--save-default":
				
				if i+1 <len(sys.argv):

					pt.write_file2(sys.argv[i+1])
					print("* Save complete")

				else:
					print "USAGE --save filename"
				break


			elif sys.argv[i]=="--load":
				
				if i+1 < len(sys.argv):

					pt.load_file(sys.argv[i+1])
					str="Cargando perfil"
					pt.clear_unmodified_values("/")
					pynotify.init("Session Notify")
					n = pynotify.Notification( str , "Espere", "user-home")
					n.set_urgency(pynotify.URGENCY_CRITICAL)
					n.show()
					pt.write_values()
					if pt.is_freeze(getpass.getuser()):
						pt.freeze()
					n.close()
					
					break
				

			elif sys.argv[i]=="--load-test":
				if i+1 < len(sys.argv):

					pt.load_file(sys.argv[i+1])
					print len(pt.dic)
					pt.clear_unmodified_values("/")
					print len(pt.dic)
					items=pt.dic.items()
					for item in items:
						print "%s == %s"%(item[0],item[1]) 				

				else:
					print "USAGE --load-test filename"
				break

			elif sys.argv[i]=="--print-keys":
				pt.read_values("/")
				pt.print_keys()
			
			elif sys.argv[i]=="--testing":
				pt.load_defaults(pt.frozen_path)
			

			elif sys.argv[i]=="--print-values":
				pt.read_values("/")
				pt.print_values()

			elif sys.argv[i]=="--print-lists":
				pt.print_lists()

			elif sys.argv[i]=="--reset":
				os.system("touch " + os.path.expanduser("~/UserFiles/.reset-gconf"))
				os.system("gnome-session-save --logout")
			else:
				pass
	
	
