#!/usr/bin/env	python

import gnome.ui
import gtk
import time
import sys
import os
import shutil
import pynotify
import gconf
import subprocess
import syslog


import threading

EXE_IN_LOGIN_PATH="/usr/share/lliurex-gnome-profile/login/"
EXE_IN_LOGOUT_PATH="/usr/share/lliurex-gnome-profile/logout/"
EXE_IN_FAILSAFE_PATH="/usr/share/lliurex-gnome-profile/failsafe/"


class Application:

	def __init__(self):

		prog=gnome.program_init("session", "0.2") 
		self.client = gnome.ui.master_client() 
		self.client.connect('die', gtk.main_quit)

		
		self.name=os.getenv("USERNAME")


		for filename in os.walk(EXE_IN_LOGIN_PATH):
			dir,something,files=filename
		
		self.gclient=gconf.client_get_default()	

		files.sort()
		
		
		syslog.syslog("lliurex-session: login")

		for file in files:
			syslog.syslog("lliurex-session: executing " + EXE_IN_LOGIN_PATH + file)
			os.system(EXE_IN_LOGIN_PATH + file)
			#subprocess.Popen([EXE_IN_LOGIN_PATH + file])


		#self.dialog=gtk.Dialog("There was a problem running your pre-shutdown script", None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,  ("Go on", gtk.RESPONSE_ACCEPT))
		
		self.client.set_priority(99)
		self.client.connect('save-yourself', self.on_logout) 
		#self.client.connect('die', self.on_logout) 
		
		
		clock=time.localtime()
		
		str="[%s/%s/%s %s:%s:%s] %s logged in...\n"%(clock.tm_mday,clock.tm_mon,clock.tm_year,clock.tm_hour,clock.tm_min,clock.tm_sec,self.name)
		#path="/home/" + self.name + "/gdm.dump"
		#f = open(os.path.expanduser("~/gdm.dump"), 'a')
		#f.write(str)
		#f.close()
		self.once=False

	#def __init__

	def on_logout(self, *args):
	
		syslog.syslog("lliurex-session: logout")
	
		if (not self.once):
			
			
			#self.gclient.disconnect()
			#dunno lol. let's try it out
			if os.path.exists(os.path.expanduser("~/UserFiles/.reset-gconf")):
				do="RESET"
			else:
				do="NORMAL"

			if do=="NORMAL":

				for filename in os.walk(EXE_IN_LOGOUT_PATH):
					dir,something,files=filename
			
				files.sort()
						
				for file in files:
					#t=threading.Thread(target=os.system,args=EXE_IN_LOGOUT_PATH + file)
					#t.start()
					syslog.syslog("lliurex-session: executing " + EXE_IN_LOGOUT_PATH + file)
					os.system(EXE_IN_LOGOUT_PATH + file)
					#subprocess.Popen([EXE_IN_LOGOUT_PATH + file])
					#print EXE_IN_LOGOUT_PATH + file

			if do=="RESET":
				
				for filename in os.walk(EXE_IN_FAILSAFE_PATH):
					dir,something,files=filename
			
				files.sort()
						
				for file in files:
					os.system(EXE_IN_FAILSAFE_PATH + file)
					#subprocess.Popen([EXE_IN_FAILSAFE_PATH + file])
					#print EXE_IN_FAILSAFE_PATH + file

			#self.gclient.save_any_dialog(self.dialog)
			
			clock=time.localtime()
			str="[%s/%s/%s %s:%s:%s] %s logged out...\n"%(clock.tm_mday,clock.tm_mon,clock.tm_year,clock.tm_hour,clock.tm_min,clock.tm_sec,self.name)
			#path='/home/' + self.name + '/gdm.dump'
			#f = open(os.path.expanduser("~/gdm.dump"), 'a')
			#f.write(str)
					
			self.once=True
			#f.close()
					

		return True



if __name__=="__main__":
	
	#user=os.getenv("USERNAME")
	
	#if user != "lliurex" and user != "root" and user !="gdm":
	
	if os.getuid() >= 5000:
		syslog.syslog("lliurex-session: detected network user") 
		Application()
		gtk.main()
	

	
	





	
